// funciones.h: declaracion de las funciones de esta DLL
// ------------------------------------------------------------------

#if !defined(_MODDLL_EXP_FUNCIONES_)
#define _MODDLL_EXP_FUNCIONES_

// Para poder exportar objetos MFC sin problemas
#undef AFX_DATA
#define AFX_DATA AFX_EXT_DATA

// ------------------------------------------------------------------
// Cabecera de una imagen

typedef struct STCabecera
{
	WORD wX;
	WORD wY;
	WORD wC;
	WORD wB;
} StCabecera;


// ------------------------------------------------------------------
// Estructura para guardar los datos d elos blobs
typedef struct STBlob
{
	float fX;
	float fY;
	float fA;
} StBlob;

// ------------------------------------------------------------------
// Funciones exportadas
// Estn reflejadas en el archivo .DEF del proyecto en el mismo orden
// ------------------------------------------------------------------

// Ejecuta las funciones de este mdulo
// iFunc		-> Funcion a realizar (0, 1, 2...)
// iNumCtr		-> Numero de controles o datos de configuracion
// iNumEnt		-> Numero de entradas
// iNumSal		-> Numero de salidas
// strTemp		-> Directorio donde estan las imagenes de entrada o salida
// pStrDatos	-> Array con los datos de configuracion, todos como cadenas de texto
// pStrImgEntr	-> Array con los nombres de las imagenes de entrada
// pStrImgSal	-> Array con los nombres de las imagenes de salida

int Ejecutar(int iFunc, int iNumCtr, int iNumEnt, int iNumSal, CString& strTemp, 
				CString* pStrDatos, CString* pStrImgEntr, CString* pStrImgSal);


// ------------------------------------------------------------------
// Funciones Privadas
// ------------------------------------------------------------------

// Leer imagen de entrada
BYTE* LeeImagenEntrada(CString& strNombre, StCabecera* pCab);

// Crear una imagen de BYTEs en forma de array del tamao indicado
BYTE** CreaImagenXY(WORD wTamX, WORD wTamY);

// Borrar una imagen de BYTEs en forma de array del tamao indicado 
void BorraImagenXY(WORD wTamX, WORD wTamY, BYTE** pImg);

//Permite la renumeracion de los blobs en el caso que sea necesario
void Reordenar(WORD pos_i, WORD pos_j, BYTE **MA, int num_abajo, int num_arriba,
			   WORD wTamX, WORD wTamY);

// Etiqueta la imagen de salida con los blobs, devolviendo el 
// numero de blobs hallados
int EtiquetaBlobs(WORD wTamX, WORD wTamY, BYTE** pEntrada, BYTE** pSalida);

// Elimina blobs con menos de iMinPixels, y devuelve nuevo numero de blobs
int EliminaBlobs(WORD wTamX, WORD wTamY, int iNumBlobs, BYTE** pSalida, int iMinPixels);

// Calcula la centro de gravedad y el angulo del eje principal del blob iBlob
void CentroGravedadXY(WORD wTamX, WORD wTamY, BYTE** pSalida, int iBlob, 
					  int& iCX, int& iCY);
					  
// Calcula el angulo del eje principal del blob iBlob (en grados)
float AnguloEje(WORD wTamX, WORD wTamY, BYTE** pSalida, int iBlob, int iCX, int iCY);

// Escribir imagne con coordenadas de blobs
BOOL EscribeBlobs(CString& strSalida, int iNumBlobs, StBlob* pBlobs);

// Escribir imagen etiquetada se salida
BOOL EscribeSalida(CString& strSalida, StCabecera* cab, BYTE** pImgSal);

// Funcion que calcula el momento de orden pq para un blob determinado
double Momento(int p, int q, int blob, BYTE **Matriz, 
			   WORD wTamX, WORD wTamY, StBlob* pBlobs);

// Funcion que calcula a partir de los momentos, los momentos centrales normalizados
// que son invariantes a posicion y escalado. 
double Momento_normalizado(int p, int q, int blob, BYTE **Matriz, 
						   WORD wTamX, WORD wTamY, StBlob* pBlobs);

// Calcula momento de Hu iOrden para el blob iBlob
float MomentoHu(WORD wTamX, WORD wTamY, int iBlob, int iOrden, 
				BYTE** pSalida, StBlob* pBlobs);

// Escribe en un archivo de imagen float los valores de los momentos de Hu
BOOL EscribirMomentosHu(CString& strSalida, int iNumBlobs, float** pMomentos);

// ------------------------------------------------------------------

#undef AFX_DATA
#define AFX_DATA

#endif // _MODDLL_EXP_FUNCIONES_
